*************************************************************
DEFINE CLASS ASPBase AS Custom 
*************************************************************
***    Author: Rick Strahl
***            (c) West Wind Technologies, 1999
***   Contact: (541) 386-2087  / rstrahl@west-wind.com
***  Modified: 12/08/98
***  Function: ASP Base class that provides basic
***            requirements for safe execution of a COM
***            component in ASP
*************************************************************

*** Custom Properties
cAppStartPath = ""
oScriptingContext = .NULL.
lError = .f.
cErrorMsg = ""


*** Stock Properties
*** Set Environment
************************************************************************
* WebTools :: Init
*********************************
***  Function: Set the server's environment. IMPORTANT!
************************************************************************
FUNCTION INIT

*** Make all required environment settings here
*** KEEP IT SIMPLE: Remember your object is created
***                 on EVERY ASP page hit!
SET RESOURCE OFF  && best to do in compiled-in CONFIG.FPW

SET EXCLUSIVE OFF
SET REPROCESS TO 2 SECONDS
SET CPDIALOG OFF

SET DELETED ON
SET EXACT OFF
SET SAFETY OFF

*** Retrieve the DLL location and grab just the path to save!
THIS.cAppStartPath = ADDBS( JustPath(Application.ServerName) )

*** Add the startup path to the path list!
*** Add any additional relative paths as required
SET PATH TO ( THIS.cAppStartpath )

ENDFUNC


************************************************************************
* aspBase :: Error
*********************************
***  Function: Error Method. Capture errors here in a string that
***            you can read from the ASP page to check for errors.
************************************************************************
FUNCTION ERROR
LPARAMETER nError, cMethod, nLine
THIS.lError = .T.
THIS.cErrorMsg= THIS.cErrorMsg + "<BR>Error No: " + STR(nError) + "<BR>  Method: " + cMethod + "<BR>  LineNo: " +STR(nLine) + "<BR>  Message: "+ message() + Message(1) + "<HR>"
ENDFUNC

#IF .F.
*** THIS NO LONGER GETS CALLED BY ASP.NET
************************************************************************
* ASPBase :: OnStartPage
*********************************
***  Function: Gets called on every load of a page. 
***      Pass: loScriptingContext  -  ASP Context Object
************************************************************************
FUNCTION OnStartPage
LPARAMETERS loScriptingContext

*** Simply assign to local reference so we can access
*** ASP objects in our code
THIS.oScriptingContext = loScriptingContext

ENDFUNC
* Webtools :: OnStartPage
#ENDIF

************************************************************************
* aspBase :: CreateObject
*********************************
***  Function: Generic Object creation routine. 
***    Assume: ClassFactory Method
***      Pass: lcName   - Name of the object to create
***    Return: oObject  - Object reference or NULL
************************************************************************
FUNCTION CreateObject
LPARAMETER lcName

oObject = CREATEOBJECT(lcName)
IF VARTYPE(oObject) # "O"
   RETURN .NULL.
ENDIF

RETURN oObject
* CreateObject

************************************************************************
* ASPBase :: Test
*********************************
***  Function: A simple test method to verify the server works
************************************************************************
Function Test
LPARAMETER lcName
IF VARTYPE(lcName) # "C"
   lcName = "Unknown"
ENDIF

RETURN "Testing for " + lcName + ". Its " + TIME()


************************************************************************
* aspBase :: GetUsername
*********************************
***  Function: returns the currently active username
************************************************************************
Function GetUserName
LPARAMETER llForceToSystem

IF llForceToSystem AND "NT" $ OS()
  DECLARE INTEGER RevertToSelf ;
      IN WIN32API
  RevertToSelf()
ENDIF      
  
DECLARE Integer GetUserName ;
   IN WIN32API AS GUserName ;
   STRING @nBuffer, ;
   INTEGER @nBufferSize

lcUserName=space(255)
lnLength=len(lcUserName)

lnError=GUserName(@lcUserName,@lnLength)
IF lnLength < 2
   RETURN ""
ENDIF   
RETURN SUBSTR(lcUsername,1,lnLength-1)

************************************************************************
* aspBase :: Get/Set Default
*****************************
FUNCTION GetDefault
RETURN SYS(5) + CURDIR()

FUNCTION SetDefault
LPARAMETER lcPath
CD (lcPath)
RETURN 

ENDDEFINE